/*******************
おとぎ芝居 (fairy rhyme) (Ver. 2.0)
Copyright 神崎渉瑠, 2008-2011
http://www.wi-wi.jp/
********************/
/*****/
function CharactorExtend(id, name, data, fld, bfld){
	this.id=id;
	this.name=name||id;

	this.defaultPose=-1; //デフォルトポーズ
	this.isAnim=false;
	
	this.cvs;

	var postures={}; // id => posture
	var _postures={}; // name => id
	var pose=-1;//表示中のポーズ

	if(!data)
		data='';
	
	var baseX=0;
	var baseY=0;
	var boxNow={
		x:0,
		y:0,
		w:-1,
		h:-1,
		z:'',
		d:0,
		flipV:false, // vertical flip
		flipH:false // holizontal flip
	};
	var boxProc={
		fx:-1,
		fy:-1,
		mx:-1,
		my:-1,
		tx:-1,
		ty:-1,
		fw:-1,
		fh:-1,
		tw:-1,
		th:-1,
		fd:0,
		td:0,
		ft:0,
		t:0
	};
	
	if(fld)
		fld.appendChild(this.cvs);
	Isolate.call(this, id, data);
	if(Balloon)
	var balloon=new Balloon(bfld, this, '', null);

	delete Isolate;
/****/
	function Isolate(id, data){
		var baseurl=AJAX_OTOGI_URL+id+'/';
		var ps=data.split('\n');
		var tmp=ps[0].split(',');
		boxProc.tx=boxProc.mx=boxProc.fx=boxNow.x=baseX=Number(tmp[0]);
		boxProc.ty=boxProc.my=boxProc.fy=boxNow.y=baseY=Number(tmp[1]);
		pose=this.defaultPose=Number(ps[1]);
		
		// ps[2]以降はポーズ
		for(var i=2,p;i<ps.length;i++){
			if(!ps[i].length)continue;
			eval('p='+ps[i]+';');
			postures[p.id]=new Posture(p.id, p.src, baseurl, p);
			_postures[p.name]=[p.id];
			p=null;
		}//for

		//defaultPose、の画像をロード
		tmp=(pose==-1)?0:pose;
		if(postures[tmp]) //ポーズが登録されていれば読み込み
			postures[tmp].Loaded();

	};//

	/****/
	this.Destroy=function(){
		for(var i in postures)
			postures[i]=null;
	};
	
	this.Loaded=function(id){
//D.Out(1, 'Loaded', this.id, ';'+id+';', postures[id]);
		if(id!==undefined && id!==null)
			if(isNaN(id))
				id=(_postures[id])?_postures[id]:0;
			return (!!postures[id])?postures[id].Loaded():true;
		
		for(var i in postures)
			if(!postures[i].Loaded())
				return false;
		return true;
	};
	
	/****
	ポジション取得
	pole.x、pole.yの位置を返す
	****/
	this.GetPos=function(){
		var ret={x:baseX, y:baseY};
		var p=postures[pose];
		if(p){
			ret.x+=p.pole.x;
			ret.y+=p.pole.y;
		}
		return ret;
	}

/*************
*************/
	this.GetSize=function(){
		var p=postures[pose];
		if(p)
			return {w:p.getWidth(), h:p.getHeight()};
		return {w:-1, h:-1};
	}

/*************
*************/
	this.ZIndex=function(idx){
		if(idx!=undefined)
			this.cvs.style.zIndex=idx;
		return this.cvs.style.zIndex;
	};//

/*************
\s[0]

this.charas[this.focus].SetPose(tmp[1]);
*************/
	this.SetPose=function(pid){
		if(pid=='-1'){
			this.cvs.style.visibility='hidden';
			pose=-1;
			return this;
		}else if(pid!=undefined && isNaN(pid)){
			pose=(_postures[pid])?_postures[pid]:0;
		}else if(pid==undefined || !postures[pid]){
			pose=0;
		}else{
			pose=pid;
		}
		if(!postures[pose])
			pose=this.defaultPose;
		if(!postures[pose])
			return this;

		this.Resize();
		this.Draw();
		this.cvs.style.visibility='visible';
		return this;
	};//

/****/
	this.SetBalloon=function(toTop){
		var xy=U.GetPos(this.cvs);
		var bsz=balloon.GetSize();

		xy[1]-=bsz.h;
		xy[0]+=U.GetSize(this.cvs).w*.5-bsz.w*.5;
		
		if(xy[0]<0) xy[0]=0;
		if(xy[0]+bsz.w>FIELD_WIDTH) xy[0]=FIELD_WIDTH-bsz.w;
		if(xy[1]<0) xy[1]=0;
		if(xy[1]+bsz.h>FIELD_HEIGHT) xy[1]=FIELD_HEIGHT-bsz.h;

//D.Out(1, 'Talk: isAnim', xy[0], xy[1]);
		if(toTop){
			balloon.MoveTop();
		}
		balloon.MoveTo(xy[0],xy[1]);

		return this;
	};//

/****/
	this.CloseBalloon=function(){
		balloon.Close();
		return this;
	};//
/****/
	this.ClearBalloon=function(){
		balloon.Clear();
		return this;
	};//

/**
トーク開始
s: 台詞
cl: 吹き出しをクリアするか
**/
	this.StartTalk=function(s, cl){
		balloon.Show(cl);
		this.SetBalloon(true);
		balloon.Serif(s);
		return this;
	};//

/****
吹き出しに１文字追加
ポーズアニメーション

停止中：
ポーズアニメーション：実行
移動アニメーション：停止
吹き出し：停止
****/
	this.Talk=function(quick){
		var isStop=(U.EI('stopplay').isStop=='1');

		//	台詞;
		var b=balloon?balloon.Run(quick):false;
		// アニメーションに合わせてバルーン位置調整
		this.SetBalloon();
		return b;
	};

/****
ポーズアニメーション
****/
	/****
	****/
	this.Animate=function(d){
		//アニメーション
		d=d||(new Date()).getTime();

		//boxProcを元にboxNowのx,y,w,h,rを計算
		if(this.isAnim){
			if(d-boxProc.ft>boxProc.t || boxProc.t==0){
				boxNow.x=boxProc.fx=boxProc.mx=boxProc.tx;
				boxNow.y=boxProc.fy=boxProc.my=boxProc.ty;
				boxNow.w=boxProc.fw=boxProc.tw;
				boxNow.h=boxProc.fh=boxProc.th;
				boxNow.d=boxProc.fd=boxProc.td;
				boxProc.t=0;
				this.isAnim=false;
			}else{
				var def=(d-boxProc.ft)/boxProc.t;

				boxNow.d=(boxProc.td-boxProc.fd)*def+boxProc.fd;

				if((boxNow.z===undefined||boxNow.z=='') && (boxNow.mode=='default')){
					var p=postures[pose];
					if(p){
						boxProc.tw=p.GetWidth();
						boxProc.th=p.GetHeight();
					}
				}
				boxNow.w=parseInt((boxProc.tw-boxProc.fw)*def+boxProc.fw);
				boxNow.h=parseInt((boxProc.th-boxProc.fh)*def+boxProc.fh);

				var m=Math.cos((90*def+30)*Math.PI*0.005556);
				var x=boxProc.tx-boxProc.fx;
				var y=boxProc.ty-boxProc.fy;
				boxNow.x=parseInt(x-x*m+boxProc.fx);
				boxNow.y=parseInt(y-y*m+boxProc.fy);

				//var cr=90*def*Math.PI*0.005556;
				//var sr=90*def*Math.PI*0.005556;
				//var x=boxProc.tx-boxProc.fx;
				//var y=boxProc.ty-boxProc.fy;
				//boxNow.x=parseInt(x-x*Math.cos(cr)+boxProc.fx);
				//boxNow.y=parseInt(y-y*Math.cos(sr)+boxProc.fy);
				
				//var r=(Math.PI/180)*(90*def);
				//var r=(2*Math.PI/360)*(90*(1-def));
				//boxNow.x=parseInt((boxProc.tx-boxProc.fx)*Math.cos(r)+boxProc.fx);
				//boxNow.y=parseInt((boxProc.ty-boxProc.fy)*Math.sin(r)+boxProc.fy);
				//boxNow.x=parseInt((boxProc.tx-boxProc.fx)*def+boxProc.fx);
				//boxNow.y=parseInt((boxProc.ty-boxProc.fy)*def+boxProc.fy);

			}
		}

		this.Draw(d);
		return this.isAnim;
	};

	/****
	再描画のみ
	****/
	this.Draw=function(d){
		if(!postures[pose]){
			return this;
		}

		postures[pose].Draw(this.cvs, boxNow, d||(new Date()).getTime());

		this.SetBalloon();
		return false;
	};

	/****
	移動
	\m[t,x,y,z]
	****/
	this.Move=function(mode, arg){
		var args=arg.split(',');
		var t=100*Number(args[0]);
		var x=args[1], y=args[2];
		boxNow.z=args[3];
		boxNow.mode=mode;
		
		boxProc.ft=(new Date()).getTime();
		boxProc.t=t;
		if(x==undefined||x=='')
			x=(mode=='default')?baseX:boxNow.x;
		if(y==undefined||y=='')
			y=(mode=='default')?baseY:boxNow.y;

		boxProc.fx=boxNow.x;
		boxProc.fy=boxNow.y;
		boxProc.tx=parseInt(x);
		boxProc.ty=parseInt(y);
		boxProc.mx=parseInt(boxProc.fx+(boxProc.tx-boxProc.fx)*.1);
		boxProc.my=parseInt(boxProc.fy+(boxProc.ty-boxProc.fy)*.1);


		this.Resize();

		this.isAnim=true;
		this.Animate(boxProc.ft);
		return this;
	};//

	/****
	リサイズ
	Draw()は呼び出さない
	****/
	this.Resize=function(m, z){
		z=z||boxNow.z;
		if(z===undefined||z==''){
			m=m||boxNow.mode;
			boxProc.fh=boxNow.h;
			boxProc.fw=boxNow.w;
			if(m=='default'){
				//初期サイズへリサイズ
				boxProc.tw=boxProc.th=-1;
			}else{
				//現在サイズなので何もしない
				boxProc.tw=boxNow.w;
				boxProc.th=boxNow.h;
			}
		}else{
			var w=boxNow.w;
			var h=boxNow.h;
			var p=postures[pose];
			if(p){
				w=p.GetWidth();
				h=p.GetHeight();
			}
			boxProc.fw=parseInt(w);
			boxProc.fh=parseInt(h);
			if(z.indexOf('%')!=-1){
				z=parseInt(z);
				if(!isNaN(z)){
					boxProc.tw=parseInt(w*z*0.01);
					boxProc.th=parseInt(h*z*0.01);
				}
				
			}else if(z.indexOf('h')!=-1){
				z=parseInt(z);
				if(!isNaN(z)){
					boxProc.tw=parseInt(w*z/h);
					boxProc.th=z;
				}
			}else if(z.indexOf('w')!=-1){
				z=parseInt(z);
				if(!isNaN(z)){
					boxProc.th=parseInt(h*z/w);
					boxProc.tw=z;
				}
			}else{
				z=parseInt(z);
				if(!isNaN(z)){
					if(w>h){
						h=parseInt(h*z/w);
						w=z;
					}else{
						w=parseInt(w*z/h);
						h=z;
					}
					boxProc.tw=w;
					boxProc.th=h;
				}
			}
		}
		this.isAnim=true;
		return this;
	};//

/****
回転
****/
	this.Rotate=function(arg){
		var r=arg.split(',');
		boxProc.ft=(new Date()).getTime();
		boxProc.t=100*Number(r[0]);
		if(isNaN(boxProc.t))
			boxProc.t=0;

		boxProc.fd=boxNow.d;
		if(r[1]=='+')
			boxProc.td=0;
		else if(r[1]=='-')
			boxProc.td=0;
		else
			boxProc.td=parseInt(r[1]);
		this.isAnim=true;
		return this;
	};
/****
反転
****/
	this.Flip=function(f){
		if(f=='v')
			boxNow.flipV=!boxNow.flipV;
		else
			boxNow.flipH=!boxNow.flipH;
		this.Draw();
		return this;
	};

/****
回転、反転を戻す
****/
	this.Restore=function(){
		boxNow.flipV=false;
		boxNow.flipH=false;
		this.Rotate('0,0');
		return this;
	};
/*************/
	this.Click=function(e){
//		if(!e)e=window.event;
		//var tar=e.target||e.srcElement;
		onDrag=false;
		//var po=U.GetPos(tar);
		if(!postures[pose])
			return this;

// e.x, e.pageX, e.clientXはドキュメントの絶対位置、po[0]はstageからの相対位置
		var po=U.GetPos(this.cvs); po[0]+=90;
		var x=(e.x||e.pageX||e.clientX||0)-po[0];
		var y=(e.y||e.pageY||e.clientY||0)-po[1];

		var region=postures[pose].HitTest(x, y);
		//this.Talk(tar, region);
		if(region){
//			U.StopEvent(e);
//			action.Get('click', this, region);

			return false;//HITした場合はfalseを返してブラウザの処理を停止する
		}
		return true; //HITしない
	};//

/*************/
	this.OnMouseMove=function(e){
		if(!e)e=window.event;
		var tar=e.target||e.srcElement;
		var po=U.GetPos(tar);
		if(onDrag){
			var x=(e.x||e.pageX||e.clientX||0)-po[0];
			var y=(e.y||e.pageY||e.clientY||0)-po[1];
			this.style.top=(dragpos.y-y)+'px';
			this.style.left=(dragpos.x-x)+'px'
			dragpos.x=e.x||e.pageX;
			dragpos.y=e.y||e.pageY;
			return this;
		}
		if(!postures[pose])
			return this;
		var x=(e.x||e.pageX||e.clientX||0)-po[0];
		var y=(e.y||e.pageY||e.clientY||0)-po[1];
		var region=postures[pose].HitTest(x, y);
	//	if(region)
	//		action.Get('mousemove', this, region);
		
		return this;
	};//

/*************/
	this.OnMouseDown=function(e){
		onDrag=true;
		dragpos.x=e.x||e.pageX||e.clientX||0;
		dragpos.y=e.y||e.pageY||e.clientY||0;
		return this;
	};//

/*************/
	this.OnMouseUp=function(){
		if(!onDrag)
			return this;
		onDrag=false;
		var x=(e.x||e.pageX||e.clientX||0)-po[0];
		var y=(e.y||e.pageY||e.clientY||0)-po[1];
		this.style.top=(dragpos.y-y)+'px';
		this.style.left=(dragpos.x-x)+'px'
		return this;
	};//

/*************/
	this.toString=function(){
		return 'chara:'+this.id+':'+this.name+';';
	};//

};//

