/*******************
おとぎ芝居 (fairy rhyme) (Ver. 2.0)
Copyright 神崎渉瑠, 2008-2011
http://www.wi-wi.jp/
********************/
/*const*/var INTERVAL_SOMETIMES=2;
/*const*/var INTERVAL_RARELY=4;
/*const*/var INTERVAL_NEVER=0;
/*const*/var INTERVAL_ALWAYS=-1;
/*const*/var INTERVAL_ONCE=-2;

function Posture(id, src, baseUrl, geo){
	this.id=id||'';
	this.src=baseUrl+src;
	
	var self=this;


// 表示位置中心
	this.pole={x:geo.pole[0]||0, y:geo.pole[1]||0}; //[0,0];

	var pose=new Image();
	pose.loaded=0;
	pose.onload=function(){
			this.loaded=1;
			self.pole={x:parseInt(this.width*0.5), y:parseInt(this.height)};
		};
	pose.onerror=function(){
			this.loaded=-1;
			self.pole={x:0, y:0};
		};

	this.Loaded=function(){
		if(!pose.loaded)
			pose.src=baseUrl+src;
		return !!pose.loaded;
	};
	
	this.GetWidth=function(){
		return pose.width;
	};
	
	this.GetHeight=function(){
		return pose.height;
	};

	this.GetPos=function(){
		return U.GetPos(pose);
	};

	/**
	描画。
	**/
	this.Draw=function(canvas, opt){
		if(pose.loaded<1){
			return this;
		}

		canvas.src=pose.src;

		var deg=opt.d;
		if(this.deg!=deg){
			this.deg=deg;
		}

		canvas.style.width='';
		canvas.style.height='';
		canvas.width=(opt.w==-1)?pose.width:opt.w;
		canvas.height=(opt.h==-1)?pose.height:opt.h;

		canvas.style.left=(opt.x-this.pole.x)+'px';
		canvas.style.top=(opt.y-this.pole.y)+'px';
//		canvas.style.left=(opt.x-this.pole.x+parseInt(pose.height*Math.cos(d2)))+'px';
//		canvas.style.top=(opt.y-this.pole.y)+'px';

		var fil='';
		if(opt.flipH){
			fil+="progid:DXImageTransform.Microsoft.BasicImage(mirror=1)";
		}
		if(opt.flipV){
			fil+="progid:DXImageTransform.Microsoft.BasicImage(rotation=2,mirror=1)";
		}

		if(opt.d){
			var d=deg*Math.PI*0.005556;
			//var d=opt.d*Math.PI/180;
			//var d=(2*Math.PI/360)*opt.d;
	
			var _sin=Math.sin(d);
			var _cos=Math.cos(d);
	
			canvas.style.filter="progid:DXImageTransform.Microsoft.Matrix(sizingmethod='auto expand');"+fil;
			canvas.filters.item(0).M11 = _cos;
			canvas.filters.item(0).M12 = -_sin;
			canvas.filters.item(0).M21 = _sin;
			canvas.filters.item(0).M22 = _cos;
		}else{
			canvas.style.filter=fil;
		}
		//canvas.onfilterchange = null;

		return this;
	};//

/**
ヒットした場合はその場所の名称
ヒットしていない場合はfalse
**/
	this.HitTest=function(x, y){
		
		
		return false;
	};//

/**************
embeded functions
**************/
	/****/
	this.toString=function(){
		return 'id:'+this.id+', src:'+pose.src+'\n';
	};//

	/****/
	this.toBoolean=function(){
		return true;
	};//

}//



/***********
擬音、描き文字、効果
***********/
function Onomatope(id, url){
	this.id=id;
	this.image=new Image();
	this.image.loaded=0;
	this.image.onload=function(){
			this.loaded=1;
		};
	this.image.onerror=function(){
			this.loaded=-1;
		};
	this.image.src=url;

	this.frames=[];
}

Onomatope.prototype.Show=function(fld, x, y, t, d){

	var self=this;
	var deg=parseInt('0'+d);
	var flip=(typeof(d)=='string')?(d.indexOf('f')!=-1):false;

	t=(t==undefined||t=='')?ONOMATOPE_INTERVAL:(t>0)?parseInt(t)*100:parseInt(t);
	var frame={
		id:(t<0)?-t:this.frames.length,
		canvas:new Image(this.image.width, this.image.height),
		tm:0
	}
	frame.canvas.className='onomatope';
	frame.canvas.style.position='absolute';
	frame.canvas.src=this.image.src;

	if(fld){
		fld.insertBefore(frame.canvas, fld.firstChild);
	}
	with(frame.canvas.style){
		top=y+'px';
		left=x+'px';
		width='';
		height='';
		display='';
	}

	var fil='';
	if(flip){
		fil+="progid:DXImageTransform.Microsoft.BasicImage(mirror=1)";
	}
	frame.canvas.style.filter=fil;

	if(t>0)
		frame.tm=setTimeout(function(){self.Hide(frame.id);}, t);

	this.frames.push(frame);

	return this;
};

Onomatope.prototype.Loaded=function(){
	return !!this.image.loaded;
};

Onomatope.prototype.Hide=function(id){
	if(id!==undefined){
		var f=this.frames[id];
		if(!f)
			return this;
		f.tm=clearTimeout(f.tm);
		f.canvas.parentNode.removeChild(f.canvas);
		delete f.canvas;
		this.frames[id]=undefined;

		// this.framesが全部undefinedならlengthを0に
		f=false;
		for(var i=0;i<this.frames.length;i++){
			if(f=(this.frames[i]!=undefined)){
				break;
			}
		}
		if(!f)
			this.frames.length=0;

	}else{
		// this.framesを全部削除
		for(var i=0,f;i<this.frames.length;i++){
			f=this.frames[i];
			if(!f)
				continue;
			f.tm=clearTimeout(f.tm);
			f.canvas.parentNode.removeChild(f.canvas);
			delete f.canvas;
			this.frames[i]=undefined;
		}
		this.frames.length=0;
	}
	return this;
};
