/*******************
おとぎ芝居 (fairy rhyme) (Ver. 2.0)
Copyright 神崎渉瑠, 2008-2011
http://www.wi-wi.jp/
********************/
/*const*/var INTERVAL_SOMETIMES=2;
/*const*/var INTERVAL_RARELY=4;
/*const*/var INTERVAL_NEVER=0;
/*const*/var INTERVAL_ALWAYS=-1;
/*const*/var INTERVAL_ONCE=-2;

function Posture(id, src, baseUrl, geo){
	this.id=id||'';
	this.src=baseUrl+src;
	
	var self=this;


// 表示位置中心
	this.pole={x:geo.pole[0]||0, y:geo.pole[1]||0}; //[0,0];

	var pose=new Image();
	pose.loaded=0;
	pose.onload=function(){
			this.loaded=1;
			self.pole={x:parseInt(this.width*0.5), y:parseInt(this.height)};
		};
	pose.onerror=function(){
			this.loaded=-1;
			self.pole={x:0, y:0};
		};

	this.Loaded=function(){
		if(!pose.loaded)
			pose.src=baseUrl+src;
		return !!pose.loaded;
	};
	
	this.GetWidth=function(){
		return pose.width;
	};
	
	this.GetHeight=function(){
		return pose.height;
	};

	this.GetPos=function(){
		return U.GetPos(pose);
	};

	/**
	描画。
	**/
	this.Draw=function(canvas, stand, now){
		if(!pose.loaded){
			pose.src=this.src;
			return this;
		}

		canvas.src=pose.src;
		canvas.width=stand.w;
		canvas.height=stand.h;
		canvas.style.width='';
		canvas.style.height='';
		// poleをbase位置に調整
		canvas.style.left=(opt.x-this.pole.x)+'px';
		canvas.style.top=(opt.y-this.pole.y)+'px';
		
		return this;
	};//


/**
ヒットした場合はその場所の名称
ヒットしていない場合はfalse
**/
	this.HitTest=function(x, y){
		
		
		return false;
	};//

/**************
embeded functions
**************/
	/****/
	this.toString=function(){
		return 'id:'+this.id+', src:'+pose.src+'\n';
	};//

	/****/
	this.toBoolean=function(){
		return true;
	};//

}//


/***********
擬音、描き文字、効果
***********/
function Onomatope(id, url){
	this.id=id;
	this.image=new Image();
	this.image.loaded=false;
	this.image.onerror=function(){
		this.loaded=true;
		};
	this.image.src=url;

	this.frames=[];
}

Onomatope.prototype.Show=function(fld, x, y, t, d){

	var self=this;
	var deg=parseInt('0'+d);
	var flip=(typeof(d)=='string')?(d.indexOf('f')!=-1):false;

	t=(t==undefined||t=='')?ONOMATOPE_INTERVAL:(t>0)?parseInt(t)*100:parseInt(t);
	var frame={
		id:(t<0)?-t:this.frames.length,
		canvas:new Image(this.image.width, this.image.height),
		tm:0
	}
	frame.canvas.className='onomatope';
	frame.canvas.style.position='absolute';
	frame.canvas.src=this.image.src;

	if(fld){
		fld.insertBefore(frame.canvas, fld.firstChild);
	}
	with(frame.canvas.style){
		top=y+'px';
		left=x+'px';
		width='';
		height='';
		display='';
	}

	if(t>0)
		frame.tm=setTimeout(function(){self.Hide(frame.id);}, t);

	this.frames.push(frame);

	return this;
};

Onomatope.prototype.Loaded=function(){
	return this.image.complete||this.image.loaded;
};

Onomatope.prototype.Hide=function(id){
	if(id!==undefined){
		var f=this.frames[id];
		if(!f)
			return this;
		f.tm=clearTimeout(f.tm);
		f.canvas.parentNode.removeChild(f.canvas);
		delete f.canvas;
		this.frames[id]=undefined;

		// this.framesが全部undefinedならlengthを0に
		f=false;
		for(var i=0;i<this.frames.length;i++){
			if(f=(this.frames[i]!=undefined)){
				break;
			}
		}
		if(!f)
			this.frames.length=0;

	}else{
		// this.framesを全部削除
		for(var i=0,f;i<this.frames.length;i++){
			f=this.frames[i];
			if(!f)
				continue;
			f.tm=clearTimeout(f.tm);
			f.canvas.parentNode.removeChild(f.canvas);
			delete f.canvas;
			this.frames[i]=undefined;
		}
		this.frames.length=0;
	}
	return this;
};
