<?php
/*******************
おとぎ芝居 (fairy rhyme) (Ver. 2.0)
Copyright 神崎渉瑠, 2008-2011
http://www.wi-wi.jp/
********************/

/*********************
管理画面
*********************/

/********/
class OtogiField {

	var $otogi_dir;
	var $otogi_url;
	
	//var $field=array(
	//		'width'=>960,
	//		'height'=>560,
	//	);
	var $scenes=array();
	var $default=0;
	var $onomas=array();

	/*******/
	function OtogiField(){
		//$w=intval('0'.get_option('otogi-field-width'));
		//$h=intval('0'.get_option('otogi-field-height'));
		//if($w)
		//	$this->field['width']=$w;
		//if($h)
		//	$this->field['height']=$h;

		$this->default=get_option('otogi-defaultscene', '-2');

		$ids=explode(',', get_option('otogi-scenes', ''));
		for($i=0,$sz=sizeof($ids);$i<$sz;$i++):
			$id=$ids[$i];
			if($id=='')
				continue;
			$this->scenes[$id]= array(
					'id'   => $id,
					'name' => get_option('otogi-s'.$id.'-name', ''),
					'src'  => get_option('otogi-s'.$id.'-src', ''),
				);
		endfor;

		$ids=explode(',', get_option('otogi-onomas', ''));
		for($i=0,$sz=sizeof($ids);$i<$sz;$i++):
			$id=$ids[$i];
			if($id=='')
				continue;
			$this->onomas[$id]= array(
					'id'   => $id,
					'name' => get_option('otogi-o'.$id.'-name', ''),
					'src'  => get_option('otogi-o'.$id.'-src', ''),
				);
		endfor;

		$up_dir=wp_upload_dir();
		$this->otogi_dir=$up_dir['basedir'].'/otogi/';
		$this->otogi_url=$up_dir['baseurl'].'/otogi/';

	}//
	
	function ListScenes(){
		
		//printf("%d,%d\n", $this->field['width'], $this->field['height']);
		printf("%d\n", $this->default);
		foreach($this->scenes as $sid=>$sc){
			printf("{id:'%s',name:'%s',src:'%s'}\n", $sc['id'], $sc['name'], $sc['src']);
		}
		
	}//
	
	function Export(){
		
		$fname = $this->otogi_dir.'scenes.txt';
		
		$fp=fopen($fname, 'w');
		flock($fp, LOCK_EX);

		//printf("%d,%d\n", $this->field['width'], $this->field['height']);
		fprintf($fp, $this->default."\n");
		foreach($this->scenes as $id=>$sc){
			fprintf($fp, "{id:'%s',name:'%s',type:'scene',src:'%s'}\n", $sc['id'], $sc['name'], $sc['src']);
		}
		foreach($this->onomas as $id=>$ono){
			fprintf($fp, "{id:'%s',name:'%s',type:'onoma',src:'%s'}\n", $ono['id'], $ono['name'], $ono['src']);
		}
		
		fclose($fp);
	}//
	
	function GetField($key, $isPrint=false){
		if($isPrint)
			echo $this->field[$key];
		return $this->field[$key];
	}//
	
	function SaveField($w=0, $h=0){
		//if($w)
		//	$this->field['width']=$w;
		//if($h)
		//	$this->field['height']=$h;
		//update_option('otogi-field-width', $this->field['width']);
		//update_option('otogi-field-height', $this->field['height']);
	}//
	
	function SaveScene($sid, $src='', $name='', $input='file'){
		if(!isset($sid))
			return false;

		if($sid>=0 && $src=='' && $name=='' && !isset($_FILE[$input]) ){
		// id指定、src、name、inputが未セットなら削除
			if(isset($this->scenes[$sid])){
				delete_option('otogi-s'.$sid.'-name');
				delete_option('otogi-s'.$sid.'-src');
				$this->scenes[$sid]['name']='';
				$this->scenes[$sid]['src']='';
				
				$this->SaveField();
			}
			return $sid;
		}

		if($sid<0){
		// 新規登録
			if(!isset($_FILES[$input])){
				//ファイルなし、エラー
				return -1;
			}

			// 新しいidを生成
			foreach($this->scenes as $id=>$value){
				if($sid<=$id)
					$sid=$id;
			}
			$sid++;
		}

		if(isset($_FILES[$input])){
		// ファイルがアップロードされていれば保存

			if(!is_dir($this->otogi_dir.'scene')){
			// ディレクトリ作成
				$up_dir=wp_upload_dir();
				$st=stat($up_dir['basedir']);
				mkdir($this->otogi_dir.'scene', $st[2]&0777, true);
			}
			
			$info=pathinfo_japanese($_FILES[$input]['name']);

			// ファイル名作成
			$ext=(($info['extension']=='')?'jpg':$info['extension']);
			if($ext!='jpg' && $ext!='gif' && $ext!='png')
				$ext='jpg';
			$src=$sid.'.'.$ext;
			
			$uploadfile = $this->otogi_dir . 'scene/'. $src;
			if(!move_uploaded_file($_FILES[$input]['tmp_name'], $uploadfile)){
				echo '<p><em class="caution">Can not move uploaded file.</em> '.$uploadfile.'</p>';
			}

			if($name==''){
			//新規作成でnameが空白なら、ファイル名をnameとする
				$name=$info['filename'];
			}//if($name=='')

		}//if(isset($_FILES[$input]))

		$this->scenes[$sid]=array(
				'id'   => $sid,
				'name' => $name,
				'src'  => $src,
			);
		
		update_option('otogi-s'.$sid.'-name', $this->scenes[$sid]['name']);
		update_option('otogi-s'.$sid.'-src', $this->scenes[$sid]['src']);

		// シーンの数を更新
		$sids=array();
		foreach($this->scenes as $sid=>$sc){
			if($sc['src']!='')
				$sids[]=$sid;
		}
		update_option('otogi-scenes', implode(',', $sids));
		return $sid;
	}

	function SaveDefaultScene($sid){
		$this->default=$sid;
		update_option('otogi-defaultscene', $sid);
	}//
	

	function SaveOnoma($id, $src='', $name='', $input='file'){
		if(!isset($id))
			return false;

		if($id>=0 && $src=='' && $name=='' && !isset($_FILES[$input]) ){
		// id指定、src、name、inputが未セットなら削除
			if(isset($this->scenes[$id])){
				delete_option('otogi-o'.$id.'-name');
				delete_option('otogi-o'.$id.'-src');
				$this->onomas[$id]['name']='';
				$this->onomas[$id]['src']='';
				
				//$this->SaveField();
			}
			return $sid;
		}

		if($id<0){
		// 新規登録
			if(!isset($_FILES[$input])){
				//ファイルなし、エラー
				return -1;
			}

			// 新しいidを生成
			foreach($this->onomas as $oid=>$value){
				if($id<=$oid)
					$id=$oid;
			}
			$id++;
		}

		if(isset($_FILES[$input])){
		// ファイルがアップロードされていれば保存

			if(!is_dir($this->otogi_dir.'onoma')){
			// ディレクトリ作成
				$up_dir=wp_upload_dir();
				$st=stat($up_dir['basedir']);
				mkdir($this->otogi_dir.'onoma', $st[2]&0777, true);
			}
			
			$info=pathinfo_japanese($_FILES[$input]['name']);
			
			//新規作成でnameが空白なら、ファイル名をnameとする
			if($name==''){
				$name=$info['filename'];
			}

			// ファイル名作成
			$ext=(($info['extension']=='')?'jpg':$info['extension']);
			//$ext=lowercase($ext);
			if($ext!='jpg' && $ext!='gif' && $ext!='png')
				$ext='jpg';
			$src=$id.'.'.$ext;
			
			$uploadfile = $this->otogi_dir . 'onoma/'. $src;
			if(!move_uploaded_file($_FILES[$input]['tmp_name'], $uploadfile)){
				echo '<p><em class="caution">Can not move uploaded file.</em> '.$uploadfile.'</p>';
			}
		}//if(isset($_FILES[$input]))
		$this->onomas[$id]=array(
				'id'   => $id,
				'name' => $name,
				'src'  => $src,
			);
		
		update_option('otogi-o'.$id.'-name', $this->onomas[$id]['name']);
		update_option('otogi-o'.$id.'-src', $this->onomas[$id]['src']);

		// シーンの数を更新
		$ids=array();
		foreach($this->onomas as $id=>$sc){
			if($sc['src']!='')
				$ids[]=$id;
		}
		update_option('otogi-onomas', implode(',', $ids));
		return $id;
	}


}//
?>