<?php
/*******************
おとぎ芝居 (fairy rhyme) (Ver. 2.0)
Copyright 神崎渉瑠, 2008-2011
http://www.wi-wi.jp/
********************/

/********/
class OtogiStory {
	var $content=''; // オリジナル
	var $script=''; // セリフ
	var $excerpt=''; // 抜粋
	var $panels=array(); // アフェリエイトコード等
	var $talks=array();
	var $charas=array(); // キャラクター
	var $errstr='';
	var $trackback=true;

	var $otogi_dir;
	var $otogi_url;

	/****/
	function OtogiStory($con=''){
		$dir_wp=wp_upload_dir();
		$this->otogi_dir=$dir_wp['basedir'].'/otogi/';
		$this->otogi_url=$dir_wp['baseurl'].'/otogi/';

		$con=str_replace(array("\n","\r"), "", $con);

		$this->content=$con;
		
		return $this;
	}

	/****/
	function DetectCharset(){
		$cset=mb_detect_encoding($this->content, 'UTF-8, SJIS, EUC-JP, JIS');
		if($cset && $cset!='UTF-8'){
			$this->content=mb_convert_encoding($this->content, 'UTF-8', $cset);
		}
		return $this;
	}
	
	/**
	SakuraScriptを話してごとに分割、配列に入れる
	\h-> \p[0], \u->\p[1] にマッピング、\p[0], \p[1] -> chara
	[ [chara, talk], [chara, talk], [...] ]
	**/
	function SplitTalk(){
		$buf;
		$tmp='';
		if(preg_match_all("/\\[panel (.*?)\\](.*?)\\[\\/panel\\]/", $this->content, $buf)){
			for($i=0;$i<sizeof($buf[0]);$i++){
				// 先頭の<br />と最後の<br />を消す
				$line=preg_replace("/<br \\/>$/", "", preg_replace("/^<br \\/>/", "", $buf[2][$i]));
				// 先頭が[url]<br />になっていれば、<br />を消す
				$line=preg_replace("/^(\\[.+?\\])<br \\/>/", "$1", $line);
				array_push($this->panels, array( (strlen($buf[1][$i])==0)?$i:$buf[1][$i], $line));
			}

		}
		$this->script=str_replace(array("\\u", "\\h"), array("\\\\p[1]", "\\\\p[0]"),
				preg_replace("/\\[panel ?.*?\\].*?\\[\\/panel\\]/",
							'',
							str_replace(array("<br />","<p>","</p>"), "", $this->content)
					)
			);
		$lines=explode("\\p", $this->script);
		$tmp="";
		foreach ($lines as $i=>$line){
			if($line==$YEN)
				continue;
			
			if(preg_match("/^\\[(.+?)\\](.*)$/", $line, $mch)){
				$p=strpos($mch[1], ',');
				$chara=($p===false)?$mch[1]:substr($mch[1], 0, $p);
				//$chara=$mch[1];
				$tmp.=$mch[2];
				array_push($this->talks, array($chara, $tmp));
				$tmp="";
			}else{
				array_push($this->talks, array('0', $line));
			}
		}
		if($tmp){
			array_push($this->talks, array('0', $tmp));
		}
		return $this;
	}//
	
	/****/
	function PrintTalkTable($id=-1){
		global $otogis, $otogi_cnt;

		$lastCharaPoses=array();

		for($i=0 ; $i<sizeof($this->charas) ; $i++){
			$lastCharaPoses[$i]='0';
		}

		// charaName => charaid 変換テーブル
		$_charas=array();
		$cids=explode(',', get_option('otogi-charas', ''));
		for($i=0,$sz=sizeof($cids);$i<$sz;$i++){
			$cid=$cids[$i];
			if($cid=='')
				continue;
			$cname=get_option('otogi-c'.$cid.'-name', ''.$cid);
			$_charas[$cname]=$cid;

		}

		$cnt=0;
		foreach($this->talks as $i=>$line){
			if($id!=-1 && $cnt>3){
				print '<p><a href="';
				the_permalink();
				print '">';
				_e('Read on');
				print '</a>';
				print '</p>';
				break;
			}
			$cnt++;
			
			$charaid=$line[0];
			$serif=$line[1];
			$panel='';
			
			// charaNameからcharaidへ変換
			if(!is_numeric($charaid)){
				$charaid=$_charas[$charaid];
			}
			
			if(!isset($this->charas[$charaid])){
				$this->charas[$charaid]= get_option('otogi-c'.$charaid.'-name', ''.$charaid);
				$lastCharaPoses[$charaid]='0';
			}
			
			if(preg_match("/\\\\[s]\\[([.]+?)\\]/", $serif, $tmp)){
			//if(preg_match("/\\\\[s]\\[([0-9,]+)\\]/", $serif, $tmp)){
				$p=strpos($tmp[1], ',');
				$lastCharaPoses[$charaid]=($p===false)?$tmp[1]:substr($tmp[1], 0, $p);

			}else{
			}

			$serif=preg_replace("/\\\\[a-z]\\[.+?\\]/", '', $serif);
			$serif=preg_replace("/\\\\n$/", '', $serif);
			$serif=preg_replace("/\\\\n/", '<br>', $serif);
			$serif=preg_replace("/\\\\[$!%\-_a-z]{1,2}(?:\\[\\d+\\])?/", '', $serif);

			if(preg_match_all("/\\\\[+=\\-\\*](\\[(.+?)\\])?/", $serif, $tmp)){
				for($j=0;$j<sizeof($tmp[0]);$j++){
					$panel=$tmp[2][$j];
					for($n=0;$n<sizeof($this->panels);$n++){
						if(''.$panel == ''.$this->panels[$n][0]){
							$panel=$this->panels[$n][1];
							break;
						}
					}
					if(strlen($panel)!=0){
						if(preg_match("/^\\[(.+?)\\]/", $panel, $pnl)){
							$tar=(strpos(get_bloginfo('url'), $pnl[1])===false)?' target="_blank"':'';
							$panel=preg_replace("/^\\[(.+?)\\]/", '', $panel);
							$panel=sprintf('<a href="%s"%s>%s</a>', $pnl[1], $tar, $panel);
						}
					}
				}//for

			}//if(preg_match_all)
			
			$serif=preg_replace("/\\\\[+=\\-\\*](?:\\[.+?\\])/", '', $serif);
			if(strlen($serif)==0){
				continue;
			}
?>
<div class="serif chara-<?php echo $charaid; ?>">
	<b class="talker">
		<img src="<?php

		$src=get_option('otogi-c'.$charaid.'-'.$lastCharaPoses[$charaid].'-src', '');
		printf("%s%d/%s",
			 $this->otogi_url,
			 $charaid,
			 $src
		); ?>" alt="<?php echo $this->charas[$charaid]; ?>" title="<?php echo get_option('otogi-c'.$charaid.'-'.$lastCharaPoses[$charaid].'-name', ''); ?>"
		width="70" height="70">
	</b>
	<p class="serif"><?php echo $serif; ?></p>
</div>
<?php
		}//foreach

		return $this;
	}//

	/****
	for html
	****/
	function PrintTalkScript($id=-1){
		echo '<script type="text/javascript">', "\n";
		$tmp='';

		if(is_page()){
			$tmp="\\_p";
		}
		$tmp=$this->script;
		$tmp=str_replace("\\\\", "&#92;&#92;", $tmp);
		$tmp=str_replace("'", "\\'", $tmp);

		if(is_single() || is_page() ){
			$cats=get_the_category();
			$cat=$cats[0];

			echo 'panels=new Array();', "\n";
			for($i=0;$i<sizeof($this->panels);$i++)
				echo 'panels[', (strlen($this->panels[$i][0])>0)?$this->panels[$i][0]:$i , ']=\'', $this->panels[$i][1], '\';', "\n";
		
			$talkInit=(is_page())?'\\\\_p':'';
			echo 'startTalk[0]={};', "\n";
			echo 'startTalk[0].title=\'', get_the_title(), '\';', "\n";
			echo 'startTalk[0].info=\'', get_the_time('Y年m月d日、H時s分'), '\';', "\n";
			echo 'startTalk[0].talk=\'', $talkInit, preg_replace("/\\\\([\-+=\\*_$%!a-z])/", "\\\\\\\\$1", $tmp), '\';', "\n";
			echo 'startTalk[0].url=\''; the_permalink(); echo '\';', "\n";
			echo 'startTalk[0].tb=\''; trackback_url(); echo '\';', "\n";
			echo 'startTalk[0].navi=\'<div class="navi"><span class="prev single">';
			previous_post_link('%link &laquo; 戻る', '%title', TRUE);
			echo '</span>';
			printf (' <span class="multi"><a href="%s/?otogi_home=%d" title="index" class="multi">%s</a></span> ', get_option('home'), $cat->cat_ID, $cat->cat_name);
			print '<span class="next single">';
			next_post_link('次へ &raquo; %link', '%title', TRUE);
			print '</span></div>\'';
			print "\n";

		}else{//if(is_single() || is_page() )
			printf("startTalk[%d]={};\n", $id);
			printf("startTalk[%d].title='%s';\n", $id, get_the_title());
			printf("startTalk[%d].info='%s';\n", $id, get_the_time('Y年m月d日、H時s分'));
			printf("startTalk[%d].talk='%s';\n", $id, preg_replace("/\\\\([\-+=\\*_$%!a-z])/", "\\\\\\\\$1", $tmp));
			printf("startTalk[%d].url='", $id); the_permalink(); print("';\n");
			print("startTalk[0].tb='';\n");
			print("startTalk[0].navi='';\n");
			printf("panels[%d]='[", $id); the_permalink(); printf("]\\n%s';\n", get_the_title());
		}//if(is_single() || is_page() )
		
		echo '</script>',"\n";
		return $this;
	}//
	
	
	/****
	for Ajax
	****/
	function PrintTalkScriptRaw(){
		echo str_replace("\\\\", "&#92;&#92;", $this->script);
		return $this;
	}//

	/****
	for Ajax
	****/
	function PrintTalkPanelsRaw(){

		for($n=0;$n<sizeof($this->panels);$n++){
			print "[panels]\n";
			echo $this->panels[$n][0], "\n";
			echo $this->panels[$n][1], "\n";
		}

		return $this;
	}//


	/****/
	function Excerpt($isOutput=false){
		global $isTB;
		if(strlen($this->excerpt)==0):
		$cnt=0;
		$i=0;
		$tmp='';
		$maxCnt=($isTB)?4:2;
		$maxLen=255;
		while($cnt<$maxCnt && isset($this->talks[$i])):
			$tmp=str_replace("\\n", "", $this->talks[$i][1]);
			$tmp=preg_replace("/\\\\(?:[_$%!a-z+=\\*\\-]{1,2})(?:\\[.+?\\])?/", "", $tmp, -1);
			if($tmp){

				$charaid=$this->talks[$i][0];
				if(!isset($this->caras[$charaid])){
					$this->charas[$charaid]= get_option('otogi-c'.$charaid.'-name', ''.$charaid);
				}

				$tmp=$this->charas[$charaid].':「'.$tmp.'」';
				if(strlen($this->excerpt) + strlen($tmp)<$maxLen){
					$this->excerpt.=$tmp;
				}else{
					//$this->excerpt.=$tmp;
					break;
				}
				$cnt++;
			}
			
			$i++;
			$tmp='';
		endwhile;
		endif;//if(strlen($this->excerpt)==0)
		if($isOutput){
			echo $this->excerpt;
			return $this;
		}else{
			return $this->excerpt;
		}
		//return $this;
	}//
	
	/****/
	function Expand(){
		$this->SplitTalk();

		return $this;
	}//
}//class

?>